/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
		V_menu: created from 13th to 15th of October 1997.
						by Ahmad Hafiz b. Wahy.
		note: please set TAB to 2.

		Vmenu is a function that is flexible function in building menu on
		the screen. The functions uses recursion techniques, by passing
		address location of the menu and it save time by calling the
		function that each menu are designed for. V_menu is so flexible
		that user just only add a few lines of code to insert or build a menu.

		There are few base rules for the user to follow when using v_menu.
		1.Each menu title must put a '-' to indicate the menu level.
		2.Functions that is a parent menu MUST NOT have pointer to function
			assigned to it. ie assigned it to NULL.
		3.Each child menu MUST HAVE pointer to function. It is a must!!!
		4.Function returning 1 will collapes the menu. otherwise 0.
		5.First char value is the hilighted character.
		7.If you want to disable the menu. put FALSE in the enable element.
		8.The bar MUST been disable to FALSE or it will print the title 'bar'
		9.Function returning 1 will collapse the menu. else the menu is still active.

modified on 17th Oct 1997
	. expert system
	. hilight key
	. what_color function
	. printchr function

	first character in the menu is the hilighted character.
	and also used by expert user. ie by pressing the expert key

modified on 26th Nov 1997  && 27th Nove 1997
	. ability to enable or disable menu added
	. addition of PGUP and PGDN key
	.	addition of bar;
	. dynamic allocation of CHILD and PARENT menu memory .!!!!
	. found that i-=nuchild+1 != i=i-nuchild+1;
	. addition of LEFT and RIGHT key

planned. (NYI)
.Addition of help function
.detecting first menu

. Bug Corrected!!!

notes: for the time being the id element in structure has no use for it.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#include <stdio.h>
#include <process.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>
#include <user\qwrite.h>
#include <user\vmenu.h>

#ifdef __SMALL__
	#error This program cannot be compiled in SMALL memory model
#endif

struct vmenu_structure *vmasterp;


int far dummyfun() { return 0; /* 1 terminate menu, 0 continue */ }
int far dummy() { return 1; /* 1 terminate menu, 0 continue */ }

/*********************************
**** vmenu sub function....
**********************************/
int v_menu_sub(struct vmenu_structure *vm[], int start_x, int start_y)
{
extern struct screen_structure scr;
extern struct window_structure w[];
extern struct menu_color mn;
struct vmenu_structure **vp;
struct vmenu_structure **vc;
int par_opt=-1;						/* parent menu counter set to -1 	*/
int cur_opt=0;						/* current option 								*/
int nu_parent;            /* number of parent_menu ref:1		*/
int nu_child;							/* number of child menu ref:1			*/
int nu_master;						/* number of master_menu ref:1		*/
int parent_win,info_win;	/* window handles									*/
int width=0;							/* window width 									*/
int found=FALSE;          /* TRUE FALSE - user request			*/
int expert=FALSE;					/* TRUE FALSE	- expert system			*/
int vcdeclared=FALSE;			/* indicator 											*/
int return_code=0;				/* return code 										*/
register int i,j,k;				/* counter 												*/
char *chtemp;							/* pointer to located hilite key	*/
char *bar;								/* string of bars 								*/
char *buffer;							/* buffer to print menu string 		*/
char id;									/* expert menu system hilite key	*/
char ch=' ', ext=' ';			/* get_key char										*/
int fore=0, back=0;				/* forecolor and background color */
int tempc=0;							/* temporary colour 							*/

	/******* determine nu_master & nu_parent ********/
	for(nu_master=0;strspn(vm[nu_master]->main,"-")>0;nu_master++);
	for(nu_parent=0,i=0;i<nu_master;i++)
		if((strspn(vm[i]->main,"-"))==1) nu_parent++;

	vp=(struct vmenu_structure **)calloc(nu_parent,sizeof(struct vmenu_structure **));

	/******* assigning parent address to master_menu address ********/
	for(i=0,j=0;j<nu_parent;i++){
		if(strspn(vm[i]->main,"-")==1) vp[j++]=vm[i];
	}

	/******* calculating width of menu window ************/
	width=0;i=0;
	do{
		if(width<strlen(&(vp[i]->main[2]))){
			width=strlen(&(vp[i]->main[2]));
		}
		else;
	i++;
	}while (i<nu_parent);

	/*********** builds the bar string ******************/
	bar=(char *)calloc(1,width+3);
	memset(bar,'',width+1);
	bar[0]='';
	bar[width+1]='';
	bar[width+2]='\x0';

	buffer=(char *)calloc(1,width+1);			/* for printing menu string */

	parent_win=win_make(start_x,start_y,width,nu_parent,STD_FRAME,NO_TITLE, mn.c_border, mn.c_normal_text);
	cursor(NO_CURSOR);

	info_win=win_make(2,25,80,1,NO_FRAME,NO_TITLE, mn.c_border, mn.c_normal_text);
	cursor(NO_CURSOR);

	/****** MAIN loop ********/
	for(;;){
		if(ext==GK_UP) cur_opt--;
		if(ext==GK_DOWN) cur_opt++;

		if(ext==GK_PGDN) cur_opt=cur_opt=nu_parent-1;
		if(ext==GK_PGUP) cur_opt=0;

		if(cur_opt>=nu_parent) cur_opt=0;
		if(cur_opt<0) cur_opt=nu_parent-1;

		if(ext==GK_RIGHT && vp[cur_opt]->fun==NULL) found=TRUE;

		for(;;){
			if(vp[cur_opt]->enable==FALSE && (ext==GK_UP || ext==GK_PGUP)) cur_opt--;
			else break;
			if(cur_opt<0) cur_opt=nu_parent-1;
		}

		for(;;){
			if(vp[cur_opt]->enable==FALSE && (ext==GK_DOWN || ext==GK_PGDN)) cur_opt++;
			else break;
			if(cur_opt>=nu_parent) cur_opt=0;
		}

		if(cur_opt>=nu_parent) cur_opt=0;
		if(cur_opt<0) cur_opt=nu_parent-1;

		if(ch==GK_RETURN) found=TRUE;
		if(ch==GK_ESCAPE || ext==GK_LEFT)
		{ return_code=0; break; }

		/* for expert user */
		if(ch>=32 && ch<=126)
			for(i=0;i<nu_parent;i++){
			id=vp[i]->main[1];										/* get the expert key */
				if(toupper(ch)==toupper(id) && vp[i]->enable==TRUE) {
					found=TRUE;
					expert=TRUE;
					cur_opt=i;
				}
			}

		if (!found || expert){   		/*  if NOT FOUND ie. user does not select */
			alt_screen(ON);											/* allowing background printing */
			win_pop_top(parent_win);						/* set parent_win as active win */
			for(i=0;i<nu_parent;i++){													 /* loop to print */
				id=vp[i]->main[1];														 /* get expert key  */
				chtemp=strchr(&vp[i]->main[2],id);						 /* find expert key */
																			/* print hilight, disabled & normal */
				if (i==cur_opt) scr.current=mn.c_selection_bar;
				else if(vp[i]->enable==FALSE && (stricmp(vp[i]->main+2,"Bar")!=0))
					scr.current=mn.c_disabled;
				else scr.current=mn.c_normal_text;

				if(vp[i]->enable==FALSE && stricmp(vp[i]->main+2,"Bar")==0){
					w[scr.active].left--;												/* print menu bar */
					w[scr.active].right++;			/* overidding left & right margin */
					update_margins();                         			/* set margin */
					scr.current=mn.c_border;
					print(1,1+i,bar);														/* prints the bar */
					scr.current=mn.c_normal_text;
					w[scr.active].left++;                  /* reset original coor */
					w[scr.active].right--;								 /* reset original coor */
					update_margins();             	/* restoring original margins */
				}

				else {
					sprintf(buffer,"%-*s",width,&vp[i]->main[2]);
					print(1,i+1,buffer);											/* print menu string */
					}

				if(vp[i]->enable==TRUE){							/* enable all TRUE menu 		*/
					what_color(mn.c_first_letter,&fore,&tempc);
					what_color(scr.current,&tempc,&back);
					scr.current=set_color(fore,back);			/* print expert key */
					printchr(strlen(&vp[i]->main[2])-strlen(chtemp)+1,1+i,id);
				}
				scr.current=scr.normal;
			}                                     				/* end of i<nu_parent */
			alt_screen(OFF);                                		/*  show screen */
		}																									/* end of NOT FOUND */

		if (found){															/* FOUND!  user selected 			*/
			par_opt=-1;														/* par_opt must be set to -1	*/
			for(i=0;i<nu_master;i++){ 						/* master loop */
				if((strspn(vm[i]->main,"-"))==1){		/* master found */
					par_opt++;												/* increase par_opt */
					if (par_opt==cur_opt){ 						/* parent found DO SEC 1,2,3 */

																				/* SECTION 1 calculating nu_child */
						for(nu_child=0,i++;nu_child<nu_master;nu_child++,i++){
							if(strspn(vm[i]->main,"-")>=2); 			/* if menu is a child */
							else {i--;break;}
						}
																				/* declaring that vc was declared */
						vcdeclared=TRUE;						/* SECTION 2 allocate memory  		*/
						vc=(struct vmenu_structure **)calloc(nu_child+1,sizeof(struct vmenu_structure **));

						i=i-nu_child+1;						/* finding the original offset of i */
						for(k=0;k<nu_child;k++){	/* SECTION 3 assigning addresses 		*/
							if(strspn(vm[i]->main,"-")>=2) 	/* if menu is a child  			*/
								vc[k]=vm[i++];       					/* assign vm address to vc  */
							else {i--;break;}
						}																			/* end SECTION 3 			*/
					}																				/* end parent found 	*/
				}																					/* end master found 	*/
			}																						/* end main loop 			*/

			if(vp[cur_opt]->fun==NULL){					/* indicates it has child 		*/
				for(i=0;i<nu_child;i++) 					/* convert ---sub1 to --sub1 	*/
					vc[i]->main=&(vc[i]->main[1]); 	/* pointer is right shifted 	*/
			vc[i]->main=NULL;							/* clean otherwise it will disturb	*/

			return_code=v_menu_sub(vc,start_x+1,start_y+cur_opt+2);
				for(i=0;i<nu_child;i++)	 					/* convert --sub1 to ---sub1 	*/
					vc[i]->main=&(vc[i]->main[-1]);	/* pointer is left shifted 	 	*/
				if(return_code==1)	break; 				/* quit main loop 						*/
			}																		/* end it has child 					*/

			else {																	/* no child found 					*/
				#pragma warn -pro											/* disable warning 					*/
				return_code=(*(vp[cur_opt]->fun))();	/* call the function 				*/
				#pragma warn +pro											/* enable warning 					*/
				win_redraw_all();											/* passing getkey	func.			*/

				if(return_code==1) break;							/* return & quit main loop 	*/
			}																				/* end it has no child 			*/
			found=FALSE; expert=FALSE;
    	ungetch(1);														/* to redraw the screen by 	*/
		}																					/* end found! 							*/

		scr.current=scr.normal;												/* print info at bottom			*/
		win_pop_top(info_win);
		win_cls(info_win);
		print(40-strlen(vp[cur_opt]->info)/2, 1,vp[cur_opt]->info);

	ch=' '; ext=' ';													/*  reset ch and ext variable */
	get_key(&ch,&ext);										/* wait for a user to press a key */
	}	/****** end of MAIN loop ********/

	free(vp);                              	 		 /* deinitialise vp memory  */
	if(vcdeclared==TRUE) free(vc); 				/* check whether vc was allocated */
	free(bar);
	free(buffer);
	win_delete(parent_win); 													/* delete menu window */
	win_delete(info_win);															/* delete info window */

return return_code;
}

/************************************************
*** vmenu....main function										***
***                                           ***
************************************************/
int v_menu(struct vmenu_structure vmaster[], int start_x, int start_y)
{
  extern struct screen_structure scr;
	struct vmenu_structure **vm;
	char old[2];
	int return_code;
	int i;
	int nu_vmaster=0; 				/* number of vmaster list */

	for(nu_vmaster=0;vmaster[nu_vmaster].main[0]!=NULL;nu_vmaster++);
	nu_vmaster++;

	vm=(struct vmenu_structure**)calloc(nu_vmaster+1,sizeof(struct vmenu_structure **));

	for(i=0;i<nu_vmaster;i++)	 /* assigning list to structure pointers */
		vm[i]=vmaster+i;

	old[0]=scr.normal; old[1]=scr.inverse;
	scr.normal=set_color(LIGHTGRAY,BLUE);
	scr.inverse=set_color(RED,BLUE);
	scr.bold_caps=FALSE;

	return_code=v_menu_sub(vm, start_x,start_y);
	free(vm);
	scr.normal=old[0];
	scr.inverse=old[1];
	return return_code;
}


